Index: code/branches/physics/src/bullet/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/BroadphaseCollision/btSimpleBroadphase.h	(revision 2430)
@@ -23,6 +23,4 @@
 struct btSimpleBroadphaseProxy : public btBroadphaseProxy
 {
-	btVector3	m_min;
-	btVector3	m_max;
 	int			m_nextFree;
 	
@@ -32,7 +30,6 @@
 	btSimpleBroadphaseProxy() {};
 
-	btSimpleBroadphaseProxy(const btPoint3& minpt,const btPoint3& maxpt,int shapeType,void* userPtr,short int collisionFilterGroup,short int collisionFilterMask,void* multiSapProxy)
-	:btBroadphaseProxy(userPtr,collisionFilterGroup,collisionFilterMask,multiSapProxy),
-	m_min(minpt),m_max(maxpt)		
+	btSimpleBroadphaseProxy(const btVector3& minpt,const btVector3& maxpt,int shapeType,void* userPtr,short int collisionFilterGroup,short int collisionFilterMask,void* multiSapProxy)
+	:btBroadphaseProxy(minpt,maxpt,userPtr,collisionFilterGroup,collisionFilterMask,multiSapProxy)
 	{
 		(void)shapeType;
@@ -57,4 +54,5 @@
 	int		m_numHandles;						// number of active handles
 	int		m_maxHandles;						// max number of handles
+	int		m_LastHandleIndex;							
 	
 	btSimpleBroadphaseProxy* m_pHandles;						// handles pool
@@ -69,4 +67,8 @@
 		m_firstFreeHandle = m_pHandles[freeHandle].GetNextFree();
 		m_numHandles++;
+		if(freeHandle > m_LastHandleIndex)
+		{
+			m_LastHandleIndex = freeHandle;
+		}
 		return freeHandle;
 	}
@@ -76,7 +78,12 @@
 		int handle = int(proxy-m_pHandles);
 		btAssert(handle >= 0 && handle < m_maxHandles);
-
+		if(handle == m_LastHandleIndex)
+		{
+			m_LastHandleIndex--;
+		}
 		proxy->SetNextFree(m_firstFreeHandle);
 		m_firstFreeHandle = handle;
+
+		proxy->m_clientObject = 0;
 
 		m_numHandles--;
@@ -93,4 +100,10 @@
 	{
 		btSimpleBroadphaseProxy* proxy0 = static_cast<btSimpleBroadphaseProxy*>(proxy);
+		return proxy0;
+	}
+
+	inline const btSimpleBroadphaseProxy*	getSimpleProxyFromProxy(btBroadphaseProxy* proxy) const
+	{
+		const btSimpleBroadphaseProxy* proxy0 = static_cast<const btSimpleBroadphaseProxy*>(proxy);
 		return proxy0;
 	}
@@ -118,4 +131,7 @@
 	virtual void	destroyProxy(btBroadphaseProxy* proxy,btDispatcher* dispatcher);
 	virtual void	setAabb(btBroadphaseProxy* proxy,const btVector3& aabbMin,const btVector3& aabbMax, btDispatcher* dispatcher);
+	virtual void	getAabb(btBroadphaseProxy* proxy,btVector3& aabbMin, btVector3& aabbMax ) const;
+
+	virtual void	rayTest(const btVector3& rayFrom,const btVector3& rayTo, btBroadphaseRayCallback& rayCallback, const btVector3& aabbMin=btVector3(0,0,0),const btVector3& aabbMax=btVector3(0,0,0));
 		
 	btOverlappingPairCache*	getOverlappingPairCache()
Index: code/branches/physics/src/bullet/BulletCollision/CMakeLists.txt
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CMakeLists.txt	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CMakeLists.txt	(revision 2430)
@@ -1,150 +1,89 @@
-ADD_LIBRARY(LibBulletCollision
-				BroadphaseCollision/btAxisSweep3.cpp
-				BroadphaseCollision/btAxisSweep3.h
-				BroadphaseCollision/btBroadphaseProxy.cpp
-				BroadphaseCollision/btBroadphaseProxy.h
-				BroadphaseCollision/btCollisionAlgorithm.cpp
-				BroadphaseCollision/btCollisionAlgorithm.h
-				BroadphaseCollision/btDispatcher.cpp
-				BroadphaseCollision/btDispatcher.h
-				BroadphaseCollision/btDbvtBroadphase.cpp
-				BroadphaseCollision/btDbvtBroadphase.h
-				BroadphaseCollision/btDbvt.cpp
-				BroadphaseCollision/btDbvt.h
-				BroadphaseCollision/btMultiSapBroadphase.cpp
-				BroadphaseCollision/btMultiSapBroadphase.h
-				BroadphaseCollision/btOverlappingPairCache.cpp
-				BroadphaseCollision/btOverlappingPairCache.h
-				BroadphaseCollision/btOverlappingPairCallback.h
-				BroadphaseCollision/btQuantizedBvh.cpp
-				BroadphaseCollision/btQuantizedBvh.h
-				BroadphaseCollision/btSimpleBroadphase.cpp
-				BroadphaseCollision/btSimpleBroadphase.h
-				CollisionDispatch/btCollisionDispatcher.cpp
-				CollisionDispatch/btCollisionDispatcher.h
-				CollisionDispatch/btCollisionObject.cpp
-				CollisionDispatch/btCollisionObject.h
-				CollisionDispatch/btCollisionWorld.cpp
-				CollisionDispatch/btCollisionWorld.h
-				CollisionDispatch/btCompoundCollisionAlgorithm.cpp
-				CollisionDispatch/btCompoundCollisionAlgorithm.h
-				CollisionDispatch/btConvexConcaveCollisionAlgorithm.cpp
-				CollisionDispatch/btConvexConcaveCollisionAlgorithm.h
-				CollisionDispatch/btDefaultCollisionConfiguration.cpp
-				CollisionDispatch/btDefaultCollisionConfiguration.h
-				CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp
-				CollisionDispatch/btSphereSphereCollisionAlgorithm.h
-				CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp
-				CollisionDispatch/btBoxBoxCollisionAlgorithm.h
-				CollisionDispatch/btBoxBoxDetector.cpp
-				CollisionDispatch/btBoxBoxDetector.h
-				CollisionDispatch/btSphereBoxCollisionAlgorithm.cpp
-				CollisionDispatch/btSphereBoxCollisionAlgorithm.h
-				CollisionDispatch/btConvexPlaneCollisionAlgorithm.cpp
-				CollisionDispatch/btConvexPlaneCollisionAlgorithm.h
-				CollisionDispatch/btSphereTriangleCollisionAlgorithm.cpp
-				CollisionDispatch/btSphereTriangleCollisionAlgorithm.h
-				CollisionDispatch/btConvexConvexAlgorithm.cpp
-				CollisionDispatch/btConvexConvexAlgorithm.h
-				CollisionDispatch/btEmptyCollisionAlgorithm.cpp
-				CollisionDispatch/btEmptyCollisionAlgorithm.h
-				CollisionDispatch/btManifoldResult.cpp
-				CollisionDispatch/btManifoldResult.h
-				CollisionDispatch/btSimulationIslandManager.cpp
-				CollisionDispatch/btSimulationIslandManager.h
-				CollisionDispatch/btUnionFind.cpp
-				CollisionDispatch/btUnionFind.h
-				CollisionDispatch/SphereTriangleDetector.cpp
-				CollisionDispatch/SphereTriangleDetector.h
-				CollisionShapes/btBoxShape.cpp
-				CollisionShapes/btBoxShape.h
-				CollisionShapes/btBvhTriangleMeshShape.cpp
-				CollisionShapes/btBvhTriangleMeshShape.h
-				CollisionShapes/btCapsuleShape.cpp
-				CollisionShapes/btCapsuleShape.h
-				CollisionShapes/btCollisionShape.cpp
-				CollisionShapes/btCollisionShape.h
-				CollisionShapes/btCompoundShape.cpp
-				CollisionShapes/btCompoundShape.h
-				CollisionShapes/btConcaveShape.cpp
-				CollisionShapes/btConcaveShape.h
-				CollisionShapes/btConeShape.cpp
-				CollisionShapes/btConeShape.h
-				CollisionShapes/btConvexHullShape.cpp
-				CollisionShapes/btConvexHullShape.h
-				CollisionShapes/btConvexPointCloudShape.cpp
-				CollisionShapes/btConvexPointCloudShape.h
-				CollisionShapes/btConvexShape.cpp
-				CollisionShapes/btConvexShape.h
-				CollisionShapes/btConvexInternalShape.cpp
-				CollisionShapes/btConvexInternalShape.h
-				CollisionShapes/btConvexTriangleMeshShape.cpp
-				CollisionShapes/btConvexTriangleMeshShape.h
-				CollisionShapes/btCylinderShape.cpp
-				CollisionShapes/btCylinderShape.h
-				CollisionShapes/btEmptyShape.cpp
-				CollisionShapes/btEmptyShape.h
-				CollisionShapes/btHeightfieldTerrainShape.cpp
-				CollisionShapes/btHeightfieldTerrainShape.h
-				CollisionShapes/btMinkowskiSumShape.cpp
-				CollisionShapes/btMinkowskiSumShape.h
-				CollisionShapes/btMaterial.h
-				CollisionShapes/btMultimaterialTriangleMeshShape.cpp
-				CollisionShapes/btMultimaterialTriangleMeshShape.h
-				CollisionShapes/btMultiSphereShape.cpp
-				CollisionShapes/btMultiSphereShape.h
-				CollisionShapes/btOptimizedBvh.cpp
-				CollisionShapes/btOptimizedBvh.h
-				CollisionShapes/btPolyhedralConvexShape.cpp
-				CollisionShapes/btPolyhedralConvexShape.h
-				CollisionShapes/btScaledBvhTriangleMeshShape.cpp
-				CollisionShapes/btScaledBvhTriangleMeshShape.h
-				CollisionShapes/btTetrahedronShape.cpp
-				CollisionShapes/btTetrahedronShape.h
-				CollisionShapes/btSphereShape.cpp
-				CollisionShapes/btSphereShape.h
-				CollisionShapes/btShapeHull.h
-				CollisionShapes/btShapeHull.cpp
-				CollisionShapes/btStaticPlaneShape.cpp
-				CollisionShapes/btStaticPlaneShape.h
-				CollisionShapes/btStridingMeshInterface.cpp
-				CollisionShapes/btStridingMeshInterface.h
-				CollisionShapes/btTriangleCallback.cpp
-				CollisionShapes/btTriangleCallback.h
-				CollisionShapes/btTriangleBuffer.cpp
-				CollisionShapes/btTriangleBuffer.h
-				CollisionShapes/btTriangleIndexVertexArray.cpp
-				CollisionShapes/btTriangleIndexVertexArray.h
-				CollisionShapes/btTriangleIndexVertexMaterialArray.h
-				CollisionShapes/btTriangleIndexVertexMaterialArray.cpp
-				CollisionShapes/btTriangleMesh.cpp
-				CollisionShapes/btTriangleMesh.h
-				CollisionShapes/btTriangleMeshShape.cpp
-				CollisionShapes/btTriangleMeshShape.h
-				CollisionShapes/btUniformScalingShape.cpp
-				CollisionShapes/btUniformScalingShape.h
-				NarrowPhaseCollision/btContinuousConvexCollision.cpp
-				NarrowPhaseCollision/btContinuousConvexCollision.h
-				NarrowPhaseCollision/btGjkEpa.cpp
-				NarrowPhaseCollision/btGjkEpa.h
-				NarrowPhaseCollision/btGjkEpa2.cpp
-				NarrowPhaseCollision/btGjkEpa2.h
-				NarrowPhaseCollision/btGjkEpaPenetrationDepthSolver.cpp
-				NarrowPhaseCollision/btGjkEpaPenetrationDepthSolver.h
-				NarrowPhaseCollision/btConvexCast.cpp
-				NarrowPhaseCollision/btConvexCast.h
-				NarrowPhaseCollision/btGjkConvexCast.cpp
-				NarrowPhaseCollision/btGjkConvexCast.h
-				NarrowPhaseCollision/btGjkPairDetector.cpp
-				NarrowPhaseCollision/btGjkPairDetector.h
-				NarrowPhaseCollision/btMinkowskiPenetrationDepthSolver.cpp
-				NarrowPhaseCollision/btMinkowskiPenetrationDepthSolver.h
-				NarrowPhaseCollision/btPersistentManifold.cpp
-				NarrowPhaseCollision/btPersistentManifold.h
-				NarrowPhaseCollision/btRaycastCallback.cpp
-				NarrowPhaseCollision/btRaycastCallback.h
-				NarrowPhaseCollision/btSubSimplexConvexCast.cpp
-				NarrowPhaseCollision/btSubSimplexConvexCast.h
-				NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
-				NarrowPhaseCollision/btVoronoiSimplexSolver.h
+SET(BulletCollision_SRCS
+	BroadphaseCollision/btAxisSweep3.cpp
+	BroadphaseCollision/btBroadphaseProxy.cpp
+	BroadphaseCollision/btCollisionAlgorithm.cpp
+	BroadphaseCollision/btDispatcher.cpp
+	BroadphaseCollision/btDbvtBroadphase.cpp
+	BroadphaseCollision/btDbvt.cpp
+	BroadphaseCollision/btMultiSapBroadphase.cpp
+	BroadphaseCollision/btOverlappingPairCache.cpp
+	BroadphaseCollision/btQuantizedBvh.cpp
+	BroadphaseCollision/btSimpleBroadphase.cpp
+	CollisionDispatch/btActivatingCollisionAlgorithm.cpp
+	CollisionDispatch/btCollisionDispatcher.cpp
+	CollisionDispatch/btCollisionObject.cpp
+	CollisionDispatch/btCollisionWorld.cpp
+	CollisionDispatch/btCompoundCollisionAlgorithm.cpp
+	CollisionDispatch/btConvexConcaveCollisionAlgorithm.cpp
+	CollisionDispatch/btDefaultCollisionConfiguration.cpp
+	CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp
+	CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp
+	CollisionDispatch/btBoxBoxDetector.cpp
+	CollisionDispatch/btGhostObject.cpp
+	CollisionDispatch/btSphereBoxCollisionAlgorithm.cpp
+	CollisionDispatch/btConvexPlaneCollisionAlgorithm.cpp
+	CollisionDispatch/btSphereTriangleCollisionAlgorithm.cpp
+	CollisionDispatch/btConvexConvexAlgorithm.cpp
+	CollisionDispatch/btEmptyCollisionAlgorithm.cpp
+	CollisionDispatch/btManifoldResult.cpp
+	CollisionDispatch/btSimulationIslandManager.cpp
+	CollisionDispatch/btUnionFind.cpp
+	CollisionDispatch/SphereTriangleDetector.cpp
+	CollisionShapes/btBoxShape.cpp
+	CollisionShapes/btBvhTriangleMeshShape.cpp
+	CollisionShapes/btCapsuleShape.cpp
+	CollisionShapes/btCollisionShape.cpp
+	CollisionShapes/btCompoundShape.cpp
+	CollisionShapes/btConcaveShape.cpp
+	CollisionShapes/btConeShape.cpp
+	CollisionShapes/btConvexHullShape.cpp
+	CollisionShapes/btConvexPointCloudShape.cpp
+	CollisionShapes/btConvexShape.cpp
+	CollisionShapes/btConvexInternalShape.cpp
+	CollisionShapes/btConvexTriangleMeshShape.cpp
+	CollisionShapes/btCylinderShape.cpp
+	CollisionShapes/btEmptyShape.cpp
+	CollisionShapes/btHeightfieldTerrainShape.cpp
+	CollisionShapes/btMinkowskiSumShape.cpp
+	CollisionShapes/btMultimaterialTriangleMeshShape.cpp
+	CollisionShapes/btMultiSphereShape.cpp
+	CollisionShapes/btOptimizedBvh.cpp
+	CollisionShapes/btPolyhedralConvexShape.cpp
+	CollisionShapes/btScaledBvhTriangleMeshShape.cpp
+	CollisionShapes/btTetrahedronShape.cpp
+	CollisionShapes/btSphereShape.cpp
+	CollisionShapes/btShapeHull.cpp
+	CollisionShapes/btStaticPlaneShape.cpp
+	CollisionShapes/btStridingMeshInterface.cpp
+	CollisionShapes/btTriangleCallback.cpp
+	CollisionShapes/btTriangleBuffer.cpp
+	CollisionShapes/btTriangleIndexVertexArray.cpp
+	CollisionShapes/btTriangleIndexVertexMaterialArray.cpp
+	CollisionShapes/btTriangleMesh.cpp
+	CollisionShapes/btTriangleMeshShape.cpp
+	CollisionShapes/btUniformScalingShape.cpp
+	Gimpact/btContactProcessing.cpp
+	Gimpact/btGImpactShape.cpp
+	Gimpact/gim_contact.cpp
+	Gimpact/btGImpactBvh.cpp
+	Gimpact/btGenericPoolAllocator.cpp
+	Gimpact/gim_memory.cpp
+	Gimpact/btGImpactCollisionAlgorithm.cpp
+	Gimpact/btTriangleShapeEx.cpp
+	Gimpact/gim_tri_collision.cpp
+	Gimpact/btGImpactQuantizedBvh.cpp
+	Gimpact/gim_box_set.cpp
+	NarrowPhaseCollision/btContinuousConvexCollision.cpp
+	NarrowPhaseCollision/btGjkEpa2.cpp
+	NarrowPhaseCollision/btGjkEpaPenetrationDepthSolver.cpp
+	NarrowPhaseCollision/btConvexCast.cpp
+	NarrowPhaseCollision/btGjkConvexCast.cpp
+	NarrowPhaseCollision/btGjkPairDetector.cpp
+	NarrowPhaseCollision/btMinkowskiPenetrationDepthSolver.cpp
+	NarrowPhaseCollision/btPersistentManifold.cpp
+	NarrowPhaseCollision/btRaycastCallback.cpp
+	NarrowPhaseCollision/btSubSimplexConvexCast.cpp
+	NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
 )
+
+ADD_LIBRARY(BulletCollision ${BulletCollision_SRCS})
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/SphereTriangleDetector.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/SphereTriangleDetector.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/SphereTriangleDetector.cpp	(revision 2430)
@@ -20,7 +20,8 @@
 
 
-SphereTriangleDetector::SphereTriangleDetector(btSphereShape* sphere,btTriangleShape* triangle)
+SphereTriangleDetector::SphereTriangleDetector(btSphereShape* sphere,btTriangleShape* triangle,btScalar contactBreakingThreshold)
 :m_sphere(sphere),
-m_triangle(triangle)
+m_triangle(triangle),
+m_contactBreakingThreshold(contactBreakingThreshold)
 {
 
@@ -41,5 +42,5 @@
 	btTransform	sphereInTr = transformB.inverseTimes(transformA);
 
-	if (collide(sphereInTr.getOrigin(),point,normal,depth,timeOfImpact))
+	if (collide(sphereInTr.getOrigin(),point,normal,depth,timeOfImpact,m_contactBreakingThreshold))
 	{
 		if (swapResults)
@@ -94,5 +95,5 @@
 
 ///combined discrete/continuous sphere-triangle
-bool SphereTriangleDetector::collide(const btVector3& sphereCenter,btVector3 &point, btVector3& resultNormal, btScalar& depth, btScalar &timeOfImpact)
+bool SphereTriangleDetector::collide(const btVector3& sphereCenter,btVector3 &point, btVector3& resultNormal, btScalar& depth, btScalar &timeOfImpact, btScalar contactBreakingThreshold)
 {
 
@@ -116,8 +117,5 @@
 	}
 
-	///todo: move this gContactBreakingThreshold into a proper structure
-	extern btScalar gContactBreakingThreshold;
-
-	btScalar contactMargin = gContactBreakingThreshold;
+	btScalar contactMargin = contactBreakingThreshold;
 	bool isInsideContactPlane = distanceFromPlane < r + contactMargin;
 	bool isInsideShellPlane = distanceFromPlane < r;
@@ -141,6 +139,6 @@
 			for (int i = 0; i < m_triangle->getNumEdges(); i++) {
 				
-				btPoint3 pa;
-				btPoint3 pb;
+				btVector3 pa;
+				btVector3 pb;
 				
 				m_triangle->getEdge(i,pa,pb);
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/SphereTriangleDetector.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/SphereTriangleDetector.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/SphereTriangleDetector.h	(revision 2430)
@@ -18,5 +18,5 @@
 
 #include "BulletCollision/NarrowPhaseCollision/btDiscreteCollisionDetectorInterface.h"
-#include "LinearMath/btPoint3.h"
+
 
 
@@ -31,5 +31,5 @@
 	virtual void	getClosestPoints(const ClosestPointInput& input,Result& output,class btIDebugDraw* debugDraw,bool swapResults=false);
 
-	SphereTriangleDetector(btSphereShape* sphere,btTriangleShape* triangle);
+	SphereTriangleDetector(btSphereShape* sphere,btTriangleShape* triangle, btScalar contactBreakingThreshold);
 
 	virtual ~SphereTriangleDetector() {};
@@ -37,5 +37,5 @@
 private:
 
-	bool collide(const btVector3& sphereCenter,btVector3 &point, btVector3& resultNormal, btScalar& depth, btScalar &timeOfImpact);
+	bool collide(const btVector3& sphereCenter,btVector3 &point, btVector3& resultNormal, btScalar& depth, btScalar &timeOfImpact, btScalar	contactBreakingThreshold);
 	bool pointInTriangle(const btVector3 vertices[], const btVector3 &normal, btVector3 *p );
 	bool facecontains(const btVector3 &p,const btVector3* vertices,btVector3& normal);
@@ -43,5 +43,5 @@
 	btSphereShape* m_sphere;
 	btTriangleShape* m_triangle;
-
+	btScalar	m_contactBreakingThreshold;
 	
 };
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.cpp	(revision 2430)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.cpp	(revision 2430)
@@ -0,0 +1,47 @@
+/*
+Bullet Continuous Collision Detection and Physics Library
+Copyright (c) 2003-2008 Erwin Coumans  http://bulletphysics.com
+
+This software is provided 'as-is', without any express or implied warranty.
+In no event will the authors be held liable for any damages arising from the use of this software.
+Permission is granted to anyone to use this software for any purpose, 
+including commercial applications, and to alter it and redistribute it freely, 
+subject to the following restrictions:
+
+1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.
+2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
+3. This notice may not be removed or altered from any source distribution.
+*/
+
+#include "btActivatingCollisionAlgorithm.h"
+#include "btCollisionDispatcher.h"
+#include "btCollisionObject.h"
+
+btActivatingCollisionAlgorithm::btActivatingCollisionAlgorithm (const btCollisionAlgorithmConstructionInfo& ci)
+:btCollisionAlgorithm(ci)
+//,
+//m_colObj0(0),
+//m_colObj1(0)
+{
+}
+btActivatingCollisionAlgorithm::btActivatingCollisionAlgorithm (const btCollisionAlgorithmConstructionInfo& ci, btCollisionObject* colObj0,btCollisionObject* colObj1)
+:btCollisionAlgorithm(ci)
+//,
+//m_colObj0(0),
+//m_colObj1(0)
+{
+//	if (ci.m_dispatcher1->needsCollision(colObj0,colObj1))
+//	{
+//		m_colObj0 = colObj0;
+//		m_colObj1 = colObj1;
+//		
+//		m_colObj0->activate();
+//		m_colObj1->activate();
+//	}
+}
+
+btActivatingCollisionAlgorithm::~btActivatingCollisionAlgorithm()
+{
+//		m_colObj0->activate();
+//		m_colObj1->activate();
+}
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.h	(revision 2430)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btActivatingCollisionAlgorithm.h	(revision 2430)
@@ -0,0 +1,36 @@
+/*
+Bullet Continuous Collision Detection and Physics Library
+Copyright (c) 2003-2008 Erwin Coumans  http://bulletphysics.com
+
+This software is provided 'as-is', without any express or implied warranty.
+In no event will the authors be held liable for any damages arising from the use of this software.
+Permission is granted to anyone to use this software for any purpose, 
+including commercial applications, and to alter it and redistribute it freely, 
+subject to the following restrictions:
+
+1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.
+2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
+3. This notice may not be removed or altered from any source distribution.
+*/
+
+#ifndef __BT_ACTIVATING_COLLISION_ALGORITHM_H
+#define __BT_ACTIVATING_COLLISION_ALGORITHM_H
+
+#include "BulletCollision/BroadphaseCollision/btCollisionAlgorithm.h"
+
+///This class is not enabled yet (work-in-progress) to more aggressively activate objects.
+class btActivatingCollisionAlgorithm : public btCollisionAlgorithm
+{
+//	btCollisionObject* m_colObj0;
+//	btCollisionObject* m_colObj1;
+
+public:
+
+	btActivatingCollisionAlgorithm (const btCollisionAlgorithmConstructionInfo& ci);
+
+	btActivatingCollisionAlgorithm (const btCollisionAlgorithmConstructionInfo& ci, btCollisionObject* colObj0,btCollisionObject* colObj1);
+
+	virtual ~btActivatingCollisionAlgorithm();
+
+};
+#endif //__BT_ACTIVATING_COLLISION_ALGORITHM_H
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.cpp	(revision 2430)
@@ -23,5 +23,5 @@
 
 btBoxBoxCollisionAlgorithm::btBoxBoxCollisionAlgorithm(btPersistentManifold* mf,const btCollisionAlgorithmConstructionInfo& ci,btCollisionObject* obj0,btCollisionObject* obj1)
-: btCollisionAlgorithm(ci),
+: btActivatingCollisionAlgorithm(ci,obj0,obj1),
 m_ownManifold(false),
 m_manifoldPtr(mf)
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxCollisionAlgorithm.h	(revision 2430)
@@ -17,5 +17,5 @@
 #define BOX_BOX__COLLISION_ALGORITHM_H
 
-#include "BulletCollision/BroadphaseCollision/btCollisionAlgorithm.h"
+#include "btActivatingCollisionAlgorithm.h"
 #include "BulletCollision/BroadphaseCollision/btBroadphaseProxy.h"
 #include "BulletCollision/BroadphaseCollision/btDispatcher.h"
@@ -25,5 +25,5 @@
 
 ///box-box collision detection
-class btBoxBoxCollisionAlgorithm : public btCollisionAlgorithm
+class btBoxBoxCollisionAlgorithm : public btActivatingCollisionAlgorithm
 {
 	bool	m_ownManifold;
@@ -32,5 +32,5 @@
 public:
 	btBoxBoxCollisionAlgorithm(const btCollisionAlgorithmConstructionInfo& ci)
-		: btCollisionAlgorithm(ci) {}
+		: btActivatingCollisionAlgorithm(ci) {}
 
 	virtual void processCollision (btCollisionObject* body0,btCollisionObject* body1,const btDispatcherInfo& dispatchInfo,btManifoldResult* resultOut);
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxDetector.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxDetector.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btBoxBoxDetector.cpp	(revision 2430)
@@ -208,5 +208,11 @@
     }
     q = p[n*2-2]*p[1] - p[0]*p[n*2-1];
-    a = 1.f/(btScalar(3.0)*(a+q));
+	if (btFabs(a+q) > SIMD_EPSILON)
+	{
+		a = 1.f/(btScalar(3.0)*(a+q));
+	} else
+	{
+		a=1e30f;
+	}
     cx = a*(cx + q*(p[n*2-2]+p[0]));
     cy = a*(cy + q*(p[n*2-1]+p[1]));
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionConfiguration.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionConfiguration.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionConfiguration.h	(revision 2430)
@@ -23,5 +23,5 @@
 ///btCollisionConfiguration allows to configure Bullet collision detection
 ///stack allocator size, default collision algorithms and persistent manifold pool size
-///todo: describe the meaning
+///@todo: describe the meaning
 class	btCollisionConfiguration
 {
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionCreateFunc.h	(revision 2430)
@@ -18,5 +18,4 @@
 
 #include "LinearMath/btAlignedObjectArray.h"
-typedef btAlignedObjectArray<class btCollisionObject*> btCollisionObjectArray;
 class btCollisionAlgorithm;
 class btCollisionObject;
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionDispatcher.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionDispatcher.cpp	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionDispatcher.cpp	(revision 2430)
@@ -58,5 +58,5 @@
 	
 	
-};
+}
 
 
@@ -79,4 +79,6 @@
 	btCollisionObject* body0 = (btCollisionObject*)b0;
 	btCollisionObject* body1 = (btCollisionObject*)b1;
+
+	btScalar contactBreakingThreshold = btMin(gContactBreakingThreshold,btMin(body0->getCollisionShape()->getContactBreakingThreshold(),body1->getCollisionShape()->getContactBreakingThreshold()));
 	
 	void* mem = 0;
@@ -90,5 +92,5 @@
 
 	}
-	btPersistentManifold* manifold = new(mem) btPersistentManifold (body0,body1,0);
+	btPersistentManifold* manifold = new(mem) btPersistentManifold (body0,body1,0,contactBreakingThreshold);
 	manifold->m_index1a = m_manifoldsPtr.size();
 	m_manifoldsPtr.push_back(manifold);
Index: code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionObject.h
===================================================================
--- code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionObject.h	(revision 2192)
+++ code/branches/physics/src/bullet/BulletCollision/CollisionDispatch/btCollisionObject.h	(revision 2430)
@@ -30,5 +30,8 @@
 #include "LinearMath/btMotionState.h"
 #include "LinearMath/btAlignedAllocator.h"
-
+#include "LinearMath/btAlignedObjectArray.h"
+
+
+typedef btAlignedObjectArray<class btCollisionObject*> btCollisionObjectArray;
 
 
@@ -72,5 +75,5 @@
 	void*			m_userObjectPointer;
 
-	///m_internalType is reserved to distinguish Bullet's btCollisionObject, btRigidBody, btSoftBody etc.
+	///m_internalType is reserved to distinguish Bullet's btCollisionObject, btRigidBody, btSoftBody, btGhostObject etc.
 	///do not assign your own m_internalType unless you write a new dynamics object class.
 	int				m_internalType;
@@ -104,5 +107,6 @@
 		CF_KINEMATIC_OBJECT= 2,
 		CF_NO_CONTACT_RESPONSE = 4,
-		CF_CUSTOM_MATERIAL_CALLBACK = 8//this allows per-triangle material (friction/restitution)
+		CF_CUSTOM_MATERIAL_CALLBACK = 8,//this allows per-triangle material (friction/restitution)
+		CF_CHARACTER_OBJECT = 16
 	};
 
@@ -111,5 +115,8 @@
 		CO_COLLISION_OBJECT =1,
 		CO_RIGID_BODY,
-		CO_SOFT_BODY
+		CO_SOFT_BODY,
+		///CO_GHOST_OBJECT keeps track of all objects overlapping its AABB and that pass its collision filter
+		///It is useful for collision sensors, explosion objects, character controller etc.
+		CO_GHOST_OBJECT
 	};
 
@@ -177,5 +184,5 @@
 	}
 
-	int	getActivationState() const { return m_activationState1;}
+	SIMD_FORCE_INLINE	int	getActivationState() const { return m_activationState1;}
 	
 	void setActivationState(int newState);
@@ -194,5 +201,5 @@
 	void	activate(bool forceActivation = false);
 
-	inline bool isActive() const
+	SIMD_FORCE_INLINE bool isActive() const
 	{
 		return ((getActivationState() != ISLAND_SLEEPING) && (getActivationState() != DISABLE_SIMULATION));
@@ -238,10 +245,10 @@
 
 
-	btBroadphaseProxy*	getBroadphaseHandle()
+	SIMD_FORCE_INLINE btBroadphaseProxy*	getBroadphaseHandle()
 	{
 		return m_broadphaseHandle;
 	}
 
-	const btBroadphaseProxy*	getBroadphaseHandle() const
+	SIMD_FORCE_INLINE const btBroadphaseProxy*	getBroadphaseHandle() const
 	{
 		return m_broadphaseHandle;
@@ -289,5 +296,5 @@
 	}
 
-	const int getIslandTag() const
+	SIMD_FORCE_INLINE int getIslandTag() const
 	{
 		return	m_islandTag1;
@@ -299,5 +306,5 @@
 	}
 
-	const int getCompanionId() const
+	SIMD_FORCE_INLINE int getCompanionId() const
 	{
 		return	m_companionId;
@@ -309,5 +316,5 @@
 	}
 
-	const btScalar			getHitFraction() const
+	SIMD_FORCE_INLINE btScalar			getHitFraction() const
 	{
 		return m_hitFraction; 
@@ -320,5 +327,5 @@
 
 	
-	const int	getCollisionFlags() const
+	SIMD_FORCE_INLINE int	getCollisionFlags() const
 	{
 		return m_collisionFlags;
